                .MODEL SMALL
                .CODE
                PUBLIC laad_lbm_init
;---------------------------------------------------------------------
;stel laad_LBM in
;al = mode :    0 -> zet het LBM-bestand op het scherm  
;               1 -> laad het LBM-bestand in het geheugen
;               2 -> zet het LBM-bestand op het scherm, zonder naar 
;                    grafische mode te gaan!   
;voor mode = 1  ds:si : wijzer naar kleurbankwijzers
;---------------------------------------------------------------------
laad_LBM_INIT   PROC    NEAR
                mov cs:[kl_ds],ds
                mov cs:[kl_si],si
                mov cs:[info],bx
                mov cs:[mode],al
                mov cs:[bytesperlijn],cx
                ret
laad_LBM_init   ENDP
;---------------------------------------------------------------------
;Inladen van een LBM - bestand
;aanroep : DS:DX -> naam
;          CF = 0   -> geen fout
;          CF = 1   -> fout       ax = foutkode
;                                 00 = kan bestand niet openen     
;                                 01 = te weinig geheugen
;                                 03 = geen LBM bestand
;                                 04 = komprimeerde LBM
;                                 05 = geen 16 kleuren
;---------------------------------------------------------------------
                PUBLIC laad_LBM
laad_LBM        PROC    NEAR
                push bx
                push cx
                push dx
                push si
                push di
                push ds
                push es
                push ax
                mov al,0
                call open_bestand     ;openen van bestand
                jnc geen_fout
laad_fout:      mov ax,0                        
                jmp laad_LBM_einde                        
;--------------------- Laden van bestand -----------------------------;
geen_fout:
                call bestand_lengte
                push ax
                push dx
                mov cx,4
deel16:         clc
                rcr dx,1
                rcr ax,1
                loop deel16
                mov bx,ax
                inc bx             ;aanvraag tot
                mov ah,48h         ;bezetten van
                int 21h            ;geheugen ("memory allocate")
                jnc geh_ok
                pop dx
                pop ax
                mov ax,1
                jmp laad_LBM_einde
geh_ok:
                mov es,ax
                mov word ptr cs:[teken_seg],ax
                mov di,0
lengte_ok:      pop dx
                pop ax
                mov cs:[len_ax],ax
                mov cs:[len_dx],dx
                cmp dx,0
                je laad02
                mov cx,dx
laad01:         call seg_laden
                call seg_ok
                loop laad01
laad02:         push dx
                push ds
                mov dx,di
                push es
                pop  ds
                mov cx,0FFFFh
                call lees_bestand
                pop ds
                pop dx
                cmp ax,0
                je gedaan_met_laden
                add di,ax
                jmp laad02
gedaan_met_laden:
;----------------- Lezen header --------------------;
                mov ax,word ptr cs:[teken_seg]
                mov ds,ax
                push cs                   ;form 
                pop es                    ;string
                mov bx,offset txt_form    ;aanwezig
                mov si,0                  ;in
                call tst_str              ;header???????
                jnc form_ok
geen_LBM:       mov ax,3                  ;Nee,
                jmp laad_LBM_einde        ;dus foutmelding
form_ok:        add si,8                  ;Interleave LBM
                mov bx,offset txt_ILBMBMHD;Bitmap Header
                call tst_str              ;aanwezig???
                jc geen_lbm               ;Nee, -> fout
                mov si,30                 ;Ja, -> OK!
                cmp byte ptr ds:[si],0    ;Gekomprimeerde
                je LBM_ok                 ;LBM???
                mov ax,4                  ;Ja! 
                jmp laad_LBM_einde        ;nog niet ondersteund ...
LBM_ok:         mov si,28                 ;Nee, in orde dus!
                mov al,[si]               ;aantal kleuren 2^si
                cmp al,04                 ;16 kleuren LBM???
                je kl_16_ok
                mov ax,5                  ;Nee! Nog niet ondersteund.
                jmp laad_LBM_einde        ;Dus foutmelding
kl_16_ok:       mov si,20                 ;Ja! Header verder lezen ...
                mov ax,cs:[kl_ds]         ;ES klaarmaken voor het 
                mov es,ax                 ;schrijven naar INFO ...
                mov ax,ds:[si]            ;Lezen breedte
                xchg ah,al                ;Intel is geen Motorola ...
                mov cs:[w],ax             ;aantal x - pixels
                mov cx,8
                mov dx,0                  ;bereken
                div cx                    ;van het
                cmp dx,0                  ;aantal           
                je xb_ok                  ;x-bytes
                inc ax
xb_ok:          mov cs:[xb],ax            ;aantal x - bytes
                add si,2                  ;Lezen van de
                mov ax,ds:[si]            ;tekening hoogte
                xchg ah,al                ;Intel is geen Motorola!!!!
                mov cs:[h],ax             ;aantal y - pixels
                cmp cs:[mode],1           ;Naar INFO schrijven???      
                jne geen_INFO
                mov di,cs:[info]          ;Maak DI klaar
                mov ax,cs:[w]             ;Haal w op ...
                stosw                     ;Bewaar w ...      
                mov ax,cs:[h]             ;Haal h op ...
                stosw                     ;Bewaar h ...
                mov ax,cs:[xb]            ;Haal xb op ...
                stosw                     ;Bewaar xb ...
                jmp geen_12
geen_INFO:      cmp cs:[mode],0           ;Is mode nul?
                jne geen_12               ;Ja, ga dan 
                mov ax,12h                ;naar VGA resolutie
                int 10h                   ;640*480 16kl.
geen_12:        mov ax,0A000h             ;Zet ES:DI 
                mov es,ax                 ;op
                mov di,0                  ;het
                mov si,0                  ;video geh.
;----------------- Ophalen van de aangepaste kleuren ----------------;
                add si,48
                mov dx,0
                mov bx,0
                mov cx,16
pal:                
                push cx
                mov bh,4
                xor ax,ax
                mov dh,[si]
                mov ch,[si+1]
                mov cl,[si+2]
                sar dh,1
                sar dh,1
                sar cl,1
                sar cl,1
                sar ch,1
                sar ch,1
                push bx
                mov ax,1007h
                int 10h
                mov bl,bh
                mov ax,1010h
                int 10h
                pop bx
                add si,3
                inc bl
                pop cx
                loop pal
;----------------- De tekening zelf tekenen ----------------------------;
                mov si,138              ;zet si op tek. info
                mov ah,1                ;ah = kl. bank1
                mov cx,cs:[h]           ;cx = tek. hoogte
volgende_rij:   push cx                 ;bewaar hoogte op stapel
                push di
volgende_kleur:                
                mov cx,cs:[xb]          ;cx = aantal x-bytes
                cmp cs:[mode],0         ;naar scherm
                je mode_is_0            ;of naar
                cmp cs:[mode],2         ;geheugen
                je mode_is_0            ;kopiren
;------- naar het geh. kopiren i.pl.v. naar het scherm ------------
LBMmode_is_1:   push ax                 ;bewaar kl. bank
                push cx                 ;+ aantal x-bytes
                push ds                 ;+ LBM_seg op stapel
                mov al,0
                xchg ah,al              ;ax = kleurbank 
                mov bx,cs:[kl_ds]       ;zet
                mov ds,bx               ;DS:BX
                mov bx,cs:[kl_si]       ;op segment adressen
                add bx,6
                cmp ax,1                ;kleurbank = 1 ???
                jne mode1_01            
                mov ax,0                ;JA! Offset juist zetten...
                jmp mode1_02
mode1_01:       cmp ax,8                ;kleurbank = 3 (2^3) ???
                jne mode1_02
                mov ax,6                ;JA! Offset juist zetten...
mode1_02:       sub bx,ax               ;Zet BX op pointer naar segment
                mov es,ds:[BX]          ;Zet ES:[DI]
                add di,ds:[BX+8]        ;op het juiste segment
                pop ds
                pop cx
                pop ax
                jmp kleur01
;-------------------------------------------------------------------
mode_is_0:                
                mov al,2                ;klaarmaken
                mov dx,03c4h            ;om naar    
                out dx,al               ;het scherm te schrijven ...
                mov al,ah               ;kleurbank
                inc dx                  ;selekteren ...
                out dx,al               ;
kleur01:
                movsb                   ;kopeer naar scherm (of geh.)
                cmp si,0                ;Overloop van SI ???
                jne si_ok
                call seg_ok_ds          ;JA! Zet SI op volgend segment ...
si_ok:          loop kleur01            ;NEE! Doe dan maar voort ...
                shl ah,1                ;Volgende kleurbank selekteren ...
                cmp ah,8                ;Alle 4 gehad? 
                jg groter_dan_8
                sub di,cs:[xb]          ;Nee!
                jmp volgende_kleur      ;Volgende kleur koperen...
groter_dan_8:   pop di                  ;JA!
                add di,cs:[bytesperlijn];Zet di op de volgende regel...
                pop cx                  ;CX = nog te koperen regels
                mov ah,1                ;kleurbank = 1
                loop volgende_rij
                clc                     ;alles ok!
                jmp laad_LBM_ok         ;Stop maar
laad_LBM_einde: pop bx
                stc                     ;Fout, dus carry zetten...
                pushf 
                cmp ax,0                ;Bestand kunnen openen???
                je  laad_LBM_ok02       ;Nee, dus ook niet sluiten!
                jmp laad_LBM_ok01       ;Ja, dus wel scluiten!
laad_LBM_ok:    pop ax
                pushf
laad_LBM_ok01:  call sluit_bestand
laad_LBM_ok02:  popf
                pop es
                pop ds
                pop di
                pop si
                pop dx
                pop cx
                pop bx
                pushf
                push es
                push ax
                mov ah,49h                ;Geef geheugen
                mov es,cs:[teken_seg]     ;weer vrij!
                int 21h                   ;(memory free)
                pop ax
                pop es
                popf
                ret
laad_LBM        ENDP
;------------------------------------------
;Vergelijk 2 strings!
;DS:SI = string
;ES:BX = te vgl string
;antwoord: CF = 0 -> hetzelfde
;          CF = 1 -> niet hetzelfde    
;------------------------------------------
tst_str         proc near
                push ax
                push di
                push si
tst_str01:      mov al,ds:[si]
                cmp al,0
                je str_ok
                cmp al,es:[bx]
                jne str_nk
                inc si
                inc bx
                jmp tst_str01
str_ok:         clc 
                jmp tst_str_ok
str_nk:         stc
tst_str_ok:     pop si
                pop di
                pop ax
                ret
tst_str         ENDP
;---------------------------------------------;
;Openen van een bestaande file
;aanroep:  call open_bestand
;          DS:DX : filenaam
;          AL    : 0 -> lezen
;                  1 -> schrijven 
;                  2 -> lezen/schrijven
;antwoord: CF = 0 -> ok!
;          CF = 1 -> fout     
;            AX bevat foutkode   
;---------------------------------------------;
open_bestand    PROC NEAR
                push cx
                xor cx,cx
                mov ah,3Dh
                int 21h
                mov word ptr cs:[filehandle],ax
                pop cx
                ret
open_bestand    ENDP
;---------------------------------------------;
;Lezen uit een geopend bestand
;aanroep : call lees_bestand
;          cx    = aantal te lezen bytes
;          DS:DX = wijzer aan databuffer
;antwoord: CF = 0 -> OK! AX = aantal lezen bytes
;          CF = 1 -> fout! AX = foutkode     
;---------------------------------------------;
lees_bestand    PROC NEAR
                push bx
                mov bx,word ptr cs:[filehandle]
                mov ah,3fh
                int 21h
                pop bx
                ret
lees_bestand    ENDP
;---------------------------------------------;
;Sluiten van het geopend bestand
;aanroep : call sluit_bestand
;antwoord: CF = 0 -> OK!
;          CF = 1 -> fout AX = foutkode
;---------------------------------------------;
sluit_bestand   PROC NEAR   
                push ax
                push bx
                mov  bx,word ptr cs:[filehandle]
                mov  ah,3Eh
                int  21h
                pop  bx
                pop  ax
                ret
sluit_bestand   ENDP
;---------------------------------------------;
;Geeft de bestand_lengte weer!
;aanroep : call bestand_lengte
;antwoord: DX:AX -> dubbel woord
;---------------------------------------------;
bestand_lengte  PROC NEAR
                push bx
                push cx
                mov  bx,word ptr cs:[filehandle]
                xor  cx,cx       ;wijzer op begin van
                xor  dx,dx       ;de file zetten
                mov  al,2        ;tot het einde van de file
                mov  ah,42h      ;
                int  21h         ;"SEEK"
                push ax
                push dx
                pushf
                xor al,al        ;begin file 
                xor cx,cx        ;wijzer op begin van
                xor dx,dx        ;de file zetten
                mov ah,42h
                int 21h
                popf
                pop  dx
                pop  ax
                pop  cx
                pop  bx
                ret
bestand_lengte  ENDP
;---------------------------------------------;
;Zet ds,si op het volgende segment
;---------------------------------------------;
seg_ok_ds       PROC NEAR
                push bx
                mov bx,ds
                add bx,01000h
                mov ds,bx
                mov si,0
                pop bx
                ret
seg_ok_ds       ENDP
;---------------------------------------------;
;Zet es,di op het volgende segment
;---------------------------------------------;
seg_ok          PROC NEAR
                push bx
                mov bx,es
                add bx,01000h
                mov es,bx
                mov di,0
                pop bx
                ret
seg_ok          ENDP
;---------------------------------------------;
;64k in es:[di] laden
;---------------------------------------------;
seg_laden       PROC    NEAR
                push cx
                push dx
                push ds
                mov cx,2
seg_laden01:
                push cx
                mov dx,di
                push es
                pop ds
                mov cx,32768
                call lees_bestand
                pop cx
                add di,ax
                loop seg_laden01
                pop ds
                pop dx
                pop cx
                ret
seg_laden       ENDP
mode            db 0
kl_ds           dw ?
kl_si           dw ?
info            dw ?
filehandle      dw ?
txt_form        db "FORM",0
txt_ILBMBMHD    db "ILBMBMHD",0
len_dx          dw 0
len_ax          dw 0
teken_seg       dw 0
w               dw 0   ;x grootte in pixels                
h               dw 0   ;y grootte in pixels
xb              dw 0   ;aantal x-bytes
bytesperlijn    dw ?
                END
